<?php

/******************************************
COPYRIGHT STUFF

Copyright 2013 Ursula Wing
www.ursart.com
 
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
see <http://www.gnu.org/licenses/>
	
******************************************/

/******************************************
README / INSTRUCTIONS

1. change settings below to a unique username and pass
2. upload this file to your hosting account
3. navigate to it via browser
4. when finished, delete this file when finished; This is only
a minimally secure application, and it would suck
if the wrong person found this page on your site
and started wreaking havoc by deleting your files.

******************************************/


/******************************************
Settings
******************************************/

//enter a username and pass for yourself
$myusername = 'me';
$mypassword = 'mypass123';

//change to false to play it safe and use your ftp client to delete files
$allowdelete = true;

//this is how many minutes before authetication times out
$sessiontimeout = 30;

/******************************************/


init_session();

if($view == 'main' || $view == 'login' || $view =='logout'):

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>i need space.</title>

<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script>
<script type="text/javascript">

var sortOption = 'name';
var sortDirection = Array();
sortDirection['name'] = 'ascending';
sortDirection['size'] = 'ascending';

jQuery(document).ready(function() {
	jQuery('#sortbysize').click(function(event){
		event.preventDefault();
		sortList('size');
	});
	
	jQuery('#sortbyname').click(function(event){
		event.preventDefault();
		sortList('name');
	});
});


function addFolderEvents(){
	//alert("addFolderEvents");
	jQuery(".expand_collapse_folder").unbind('click');
	jQuery(".expand_collapse_folder").click(function(event){
		expandCollapseToggle(event);		
	  });
	  
	jQuery(".delete").unbind('click');
	jQuery('.delete').click(function(event){
		event.preventDefault();
		deleteFile(event);
	});
}

function deleteFile(event){
	event.preventDefault();
	var deleteNode = jQuery(event.target);	
	var fileToDelete = deleteNode.attr("filetodelete");
	var row = deleteNode.parent().parent();
	
	var answer = confirm ("Are you sure you want to delete " + fileToDelete + "?\nThis cannot be undone.");
	var loadUrl = "?view=delete&filetodelete="+fileToDelete;
	
	if (answer){
		deleteNode.load(loadUrl, function() { 
			row.slideToggle(500);
		});
	}else{
		
	}
}


function expandCollapseToggle(event){
	event.preventDefault();
	
	var expandCollapseNode = jQuery(event.target);	
	var childrenNodeId = expandCollapseNode.attr("child_node_id");
	var childrenNode = jQuery("#"+childrenNodeId);

	if (expandCollapseNode.html() == "+"){
			  
		var dir = expandCollapseNode.attr("dirrequest");
		var level = expandCollapseNode.attr("level");
		var directoryNode = expandCollapseNode.parent().parent();
		var filenameNode = expandCollapseNode.parent();
	
		var loadUrl = "?dirrequest="+dir+"&level="+(parseInt(level)+1)+"&sort="+sortOption+"&sortdirection="+sortDirection[sortOption];

		//childrenNode.html("<div style='margin-left:"+(parseInt(level)+1)*30+"px'>loading...</div>");
		filenameNode.append("<div id='status' style='display:inline-block;margin-left:10px'>loading...</div>");
		childrenNode.load(loadUrl, function() { 
			
			childrenNodeHeight = childrenNode.height();
			childrenNodeWidth = childrenNode.width();
			childrenNode.width(childrenNodeWidth);
			childrenNode.height(childrenNodeHeight);
			childrenNode.hide();		
			filenameNode.children('#status').remove();
			
			childrenNode.slideToggle(500, function(){
				childrenNode.css({
					overflow: 'visible',
					height: 'auto',
					width: '100%'
				});
				
			});
		});
		
		expandCollapseNode.html("-");
	}else{
		childrenNode.slideToggle(500);
		expandCollapseNode.html("+");
	}
	return false;
}

function updateSortParams(sorton){
	if (sortOption == sorton){
		//change the direction
		
		if (sorton == 'size'){
			if (sortDirection['size'] == 'ascending'){
				sortDirection['size'] = 'descending';
			}else{
				sortDirection['size'] = 'ascending';
			}
		}else{
			if (sortDirection['name'] == 'ascending'){
				sortDirection['name'] = 'descending';
			}else{
				sortDirection['name'] = 'ascending';
			}
		}	
	}
	
	sortOption = sorton;
}

function sortList(sorton){
	
	updateSortParams(sorton);
	
	var parentNodes = jQuery('.datacontent');
	
	for (var i=parentNodes.length - 1; i>=0; i--) {
		var parentNode = jQuery(parentNodes[i]);
		
		var listNodes = parentNode.children('.holder');
		
		if (listNodes.length > 0){

			if (sorton == 'size'){
				listNodes.sort(function(b, a) {
		
					var compAnode = jQuery(a).find('.filesize')[0];
					var compBnode = jQuery(b).find('.filesize')[0];
						   
					var compA = jQuery(compAnode).attr('bytes');
					var compB =jQuery( compBnode).attr('bytes');

					if (sortDirection['size'] == 'ascending'){
						result = compA - compB;
					}else{
						result = compB - compA;
					}
					
					return result;
				});
				
			}else{
				
				listNodes.sort(function(b, a) {
		
					var compAnode = jQuery(a).find('#filelink')[0];
					var compBnode = jQuery(b).find('#filelink')[0];
						
					var compA = jQuery(compAnode).html();
					var compB =jQuery( compBnode).html();
		

					if (sortDirection['name'] == 'ascending'){
						if(compA>compB) return -1;
						if(compA<compB) return 1;
						return 0;
					}else{
						if(compA<compB) return -1;
						if(compA>compB) return 1;
						return 0;
					}				
				});
			}
			
			var newhtml = '';
			
			for (var j = 0; j <listNodes.length; j++){
				newhtml += listNodes[j].outerHTML;
			}
			parentNode.html(newhtml);
		}
	}
	addFolderEvents();
}


</script>

<link href='http://fonts.googleapis.com/css?family=Rock+Salt' rel='stylesheet' type='text/css'>

<style type="text/css">
html{
	margin: 0;
	padding: 0;
}
body{
	font-family:Arial, Helvetica, sans-serif;
	font-size:12px;	
	margin: 0 10px 0 10px;
	padding: 0;
}

a{
	text-decoration:none;	
}

a:hover{
	color:#FF0000;	
}

h1{
	font-family: 'Rock Salt', cursive;
	margin-bottom: 4px;
	margin-top:4px;
}

div.nav{
	margin: 0 0 4px 0;
	display:inline-block;
	width:100%;
	border-bottom: solid 1px #999;

}
/*
div.nav a{
	text-decoration:underline;	
}
*/
div.holder{
	clear:both;
	width:100%;
	float:left;
	position:relative;
}

div.inner{
	background: #ffffff; /* Old browsers */
	background: -moz-linear-gradient(top,  #ffffff 0%, #dae0e8 99%); /* FF3.6+ */
	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#ffffff), color-stop(99%,#dae0e8)); /* Chrome,Safari4+ */
	background: -webkit-linear-gradient(top,  #ffffff 0%,#dae0e8 99%); /* Chrome10+,Safari5.1+ */
	background: -o-linear-gradient(top,  #ffffff 0%,#dae0e8 99%); /* Opera 11.10+ */
	background: -ms-linear-gradient(top,  #ffffff 0%,#dae0e8 99%); /* IE10+ */
	background: linear-gradient(to bottom,  #ffffff 0%,#dae0e8 99%); /* W3C */
	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ffffff', endColorstr='#dae0e8',GradientType=0 ); /* IE6-9 */
	border-bottom: solid 1px #fff;
	clear:both;
	width:100%;
	float:left;
	position:relative;

}

div.filename{
	width:auto;
	float:left;
	overflow:hidden;
	padding-left:10px;
}

div.filesize{
	text-align:right;width:auto;float:right;
}

a.delete{
	float:right;
	margin-left: 8px;
	padding: 0 1px 0 1px;
	background: #fff;
	border: solid 1px #999999;
}

div.delete{
	float:right;
	width: 44px;
}

div.inner:hover{
	background: #FCFCFC !important;
}

.expand_collapse_folder{
	width:10px;
	margin-left:-10px;
}

.hidden{
	width:100%;
	float:left;
	clear:both;
	overflow: hidden;
	position:relative;
}

#sortbysize{
	<?php 
	if ($allowdelete){
		echo "margin-right:46px;";
	}
	?>
}

#location{
	width:100%;
	text-align:center;	
}

#admin{
	float:right;	
}

input{
	float:right;
}

form{
	width: 270px;	
	margin: 10px auto 0 auto;
}

form div{
	width:100%;
	display:inline-block;
	margin: 0 0 2px 0;	
}

</style>
</head>

<body>
<div id='admin'>

<?php 
	if ($view != 'login' && $view != 'logout'){
		echo "Hello ".$user." <a href='?view=logout'>log out</a>";
	}
?>

</div>


<h1>Arg. I need space.</h1>


<div class="nav">

<?php if($view == 'main'): ?>
<div id='location'>Now viewing: <?php  echo $dir ?></div>

	<div class='filename'>
    	<strong><a href='#' id='sortbyname'>Name</a></strong>
     </div>
     <div class='filesize'>
     	<strong><a href='?sort=size<?php echo $sizelinkparams ?>' id='sortbysize'>Size</a></strong>
      </div>
      
<?php endif ?>      
      
</div><!-- begin data -->

<div class='datacontent'>

<?php endif ?>


<?php



 function getSingleDirectory($path = '.', $level = 0){
	 global $view, $initPath, $sort, $sortdirection;

	 $ignore = array( 'cgi-bin', '.', '..' );
    // Directories to ignore when listing output. Many hosts
    // will deny PHP access to the cgi-bin.

	if (empty($all_dir_names_sizes)){
		$all_dir_names_sizes = array();	
	}
	
    $dh = @opendir( $path );
    // Open the directory to the handle $dh
	    
    while( false !== ( $file = readdir( $dh ) ) ){
    // Loop through the directory
    
        if( !in_array( $file, $ignore ) ){
        // Check that this file is not to be ignored
		
			$spaces = str_repeat( '&nbsp;', ( $level * 4 ) );
			// Just to add spacing to the list, to better
			// show the directory tree.
			
			$dir_name_size = array();
			$dir_name_size['path'] = $path;
			$dir_name_size['file'] = $file;
			$dir_name_size['spaces'] = $spaces;
			$dir_name_size['dh'] =  str_replace('Resource id #', 'dh_', $dh);
			$dir_name_size['level'] = $level;
				
			if( is_dir( "$path/$file" ) ){
					
				$directoryinfo = getDirectorySize($path."/".$file);
				
				$dir_name_size['is_dir'] = true;
				$dir_name_size['size'] = $directoryinfo['size'];
				            
            } else {
				$dir_name_size['size'] = filesize($path."/".$file);
				$dir_name_size['is_dir'] = false;
            }			
			array_unshift($all_dir_names_sizes, $dir_name_size);
        }
    }
    
    // Close the directory handle
    closedir( $dh );
	
	//sort alphabetically by default
	if ($sort == 'name'){
		usort($all_dir_names_sizes, 'sortByName');
	}
	if ($sort == 'size'){
		usort($all_dir_names_sizes, 'sortBySize');
	}
	
	return $all_dir_names_sizes;
}

 function sortByName($x, $y){
	 global $sortdirection;
	 
	 $a = strtolower($x['file']);
	 $b = strtolower($y['file']);
	 
	if ($a == $b){ 
		return 0;
	}elseif ($a > $b){
		 if ($sortdirection == 'ascending'){
			return 1;
		 }else{
			return -1; 
		 }
	}else {
		if ($sortdirection == 'ascending'){
			return -1;
		}else{
			return 1;
		}
	}
 }
 
 function sortBySize($x, $y){
	global $sortdirection;
	
	$a = $x['size'];
	$b = $y['size'];
	 
	 if ($a == $b){ 
		return 0;
	}elseif ($a > $b){
		 if ($sortdirection == 'ascending'){
			return -1;
		 }else{
			return 1; 
		 }
	}else {
		if ($sortdirection == 'ascending'){
			return 1;
		}else{
			return -1;
		}
	}
 }

function printData($data){
	global $requestlevel, $dir, $allowdelete;
	
	$html = '';
	
	if ($dir != '.'){
		// all user to go up one directory
		$up_one_dir = array();
		$up_one_dir['path'] = "";
		$up_one_dir['file'] = "..";
		$up_one_dir['dh'] =  "up";
		$up_one_dir['level'] = 0;
		$up_one_dir['is_dir'] = false;
		$up_one_dir['size'] = 0;

		array_unshift($data, $up_one_dir);
	}
	
	foreach ($data as $key => $val) {
		//$spaces = $val['spaces'];
		$size = $val['size'];
		$file = $val['file'];
		$path = $val['path'];
		$is_dir =  $val['is_dir'];
		$dh = $val['dh'];
		$level = $val['level'];
				
		$fullpath = $path."/".$file;
		$urlpath = urlencode($fullpath);
	
		$cleanpath = str_replace(" ","_", str_replace("/","_",str_replace(".", "_", $fullpath)));
		$html .= "<div class='holder'>\n";
		$html .= "<div class='inner'>\n";
		
		$html .= "<div class='filename' style='margin-left:".($requestlevel*30)."px'>";
	
		if ($is_dir && $urlsortparam == ''){
			$html .= "<a href='#' style='text-decoration:none' class='expand_collapse_folder' alt='click to view folder contents' dirrequest='".$urlpath."' child_node_id='".$dh.$key.$cleanpath."' level='".$requestlevel."'>+</a>&nbsp;";
		}

		$urlparams = '?dir='.$urlpath;
		if (!empty($sortoption)){
			$urlparams .= '&'.$urlsortparam;
		}
		
		if ($dh != "up"){

			if ($is_dir){
				$html .= "<a id='filelink' alt='browse this directory' href='".$urlparams."'>";
			}else{
				$html .= "<a id='filelink' href='".$fullpath."'>";
			}
			
		}else{
			//parse dir param
			$directories = explode("/", $dir);
			array_pop($directories);
			
			$html .= "<a id='one_dir_up' href='?dir=".implode("/", $directories)."'>";
			
		}
	
		$html .= $file;
		$html .= "</a>";

		$html .= "</div>\n";
	
		if ($dh != "up"){
			
			if ($allowdelete ){
				
				if ( $file == get_this_file()){
					$html .= "<div class='delete'>&nbsp;</div>";					
				}else{
					$html .= "<a href='#' class='delete' filetodelete='".$fullpath."' >delete</a>";	
				}
			}
			$html .= "<div class='filesize' bytes='".$size."'>";	
			$html .= sizeFormat($size);
			$html .= "</div>\n";
		}
		
		$html .= "</div><!-- .inner	 -->\n";
		
		if ($is_dir){
			//this is a hidden holder for the child files if user expands
			$html .= "<div class='hidden datacontent' id='".$dh.$key.$cleanpath."'></div><!-- children holder -->\n";
		}
		$html .= "</div><!-- .holder -->\n";
	}
	
	$html .= '<script type="text/javascript">
jQuery(document).ready(function() {
	addFolderEvents();  
});
</script>';
	
	echo $html;
	
}

function getDirectorySize($path)
{
  $totalsize = 0;
  $totalcount = 0;
  $dircount = 0;
  if ($handle = opendir ($path))
  {
    while (false !== ($file = readdir($handle)))
    {
      $nextpath = $path . '/' . $file;
      if ($file != '.' && $file != '..' && !is_link ($nextpath))
      {
        if (is_dir ($nextpath))
        {
          $dircount++;
          $result = getDirectorySize($nextpath);
          $totalsize += $result['size'];
          $totalcount += $result['count'];
          $dircount += $result['dircount'];
        }
        elseif (is_file ($nextpath))
        {
          $totalsize += filesize ($nextpath);
          $totalcount++;
        }
      }
    }
  }
  closedir ($handle);
  $total['size'] = $totalsize;
  $total['count'] = $totalcount;
  $total['dircount'] = $dircount;
  return $total;
}

function sizeFormat($size)
{
    if($size<1024)
    {
        return $size." bytes";
    }
    else if($size<(1024*1024))
    {
        $size=round($size/1024,1);
        return $size." KB";
    }
    else if($size<(1024*1024*1024))
    {
        $size=round($size/(1024*1024),1);
        return $size." MB";
    }
    else
    {
        $size=round($size/(1024*1024*1024),1);
        return $size." GB";
    }

}  

function get_this_file(){
	global $thisfile;
	
	if (empty($thisfile)){
		$currentFile = $_SERVER["PHP_SELF"];
		$parts = Explode('/', $currentFile);
		$thisfile = $parts[count($parts) - 1];
	}
	
	return $thisfile;
}

function init_session(){
	
	global  $view, $dir, $dirrequest, $user, $pass, $requestlevel, $sort, $sortdirection, $todelete, $thisfile, $sessiontimeout;

	session_start();
	
	if (!empty($_POST['smwig_user'])){
		$user = $_POST['smwig_user'];
	}
	if (!empty($_POST['smwig_pass'])){
		$pass = $_POST['smwig_pass'];
	}
	
	$dir = '.';
	
	if(isset($_SESSION['user']) && isset($_SESSION['timeout'])){
		if ($_SESSION['timeout'] + $sessiontimeout * 60 > time()) {
			$user = $_SESSION['user'];
			$view = 'main';
			
			if (!empty($_GET['view'])){
				$view = $_GET['view'];
			}
			
			if (!empty($_GET['dirrequest'])){
				$dirrequest = $_GET['dirrequest'];
				$view = 'directory';
			}
			if (!empty($_GET['dir'])){
				$dir = $_GET['dir'];
			}
						
		}else{
			$view = 'login';
		}
	}else{
		if (check_user()){
			$view = 'main';
		}else{
			$view = 'login';
		}
	}
	
	if (!empty($_GET['level'])){
		$requestlevel = intval($_GET['level']);
	}else{
		$requestlevel = 0;	
	}
	
	$sort = 'name';
	
	if (!empty($_GET['sort'])){
		$sort = $_GET['sort'];
	}
	$sortdirection = 'ascending';
	if (!empty($_GET['sortdirection'])){
		$sortdirection = $_GET['sortdirection'];
	}
	if (!empty($_GET['filetodelete'])){
		$todelete = $_GET['filetodelete'];
	}
		
}

function new_session(){

	session_destroy();
	session_start();
		
	$html = '<form method="POST" action="'.$_SERVER['PHP_SELF'].'">
	  <div>Username: <input type="text" name="smwig_user" id="user" size="25" /></div>
	  <div>Password: <input type="password" name="smwig_pass" id="pass" size="25" /></div>
	  <div><input type="submit" value="Login" /></div>
	</form>';
	
	echo $html;
}

function check_user(){
	global  $user, $pass, $myusername, $mypassword;

	if ($myusername == $user && $mypassword == $pass){
		//let 'em in
		$_SESSION['user'] = $user;
		$_SESSION['timeout'] = time();
		
		return true;
	}
	
	return false;
}

function init(){
	global $view, $dirrequest, $dir, $todelete, $allowdelete;

	switch($view){
		case 'directory':
			$data = getSingleDirectory($dirrequest);
			printData($data);
		break;	
		case 'main':
			$data = getSingleDirectory($dir);
			printData($data);
		break;	
		case 'login':
			new_session();
		break;	
		case 'delete':
			if ($allowdelete){
				unlink($todelete);
			}
		break;
		case 'logout':
			new_session();
		break;
		case 'default':
		
		
		break;					
		
	}
}

init();


?> 

<?php if($view == 'main' || $view == 'login' || $view =='logout'): ?>
</div><!-- end datacontent-->

</body>
</html>

<?php endif ?>